include: 'poll.yml'

default:
  image: linaro/jenkins-amd64-debian:bullseye
  tags:
    - custom-intel

variables: &intel_resources
  KUBERNETES_CPU_REQUEST: 8
  KUBERNETES_MEMORY_REQUEST: 8G
  KUBERNETES_EPHEMERAL_STORAGE_REQUEST: 25G

variables:
  <<: *intel_resources
  MANIFEST_URL:
    value: 'https://github.com/96boards/oe-rpb-manifest.git'
    description: 'Manifest repository'
  MANIFEST_BRANCH:
    value: ''
    description: 'Manifest repository branch name'
  FORCE_TRIGGER:
    value: 'false'
    description: 'Forcer trigger downstream job even in manifest does not change'
  JFROG_UPLOAD_DRY_RUN:
    value: 'false'
    description: 'Boolean defining upload artifact dry-run'

  # variables set by branch type
  IMAGES: ''
  IMAGES_RPB: ''
  IMAGES_RPB_WAYLAND: ''
  BUILD_SDK: ''

  # cache android repo tool variables
  REPO_DIR: $CI_PROJECT_DIR/repo/
  REPO_INFO: $CI_PROJECT_DIR/info
  REPO_DIFFMANIFESTS: $CI_PROJECT_DIR/diffmanifests

  # triggered mock project path
  MOCK_PROJECT_PATH: 'lt-qcom-gitlab-ci/oe/oe-mock'

  # triggered project paths
  OE_PROJECT_PATH: 'lt-qcom-gitlab-ci/oe/oe'
  LINUX_TESTIMAGES_PROJECT_PATH: 'lt-qcom-gitlab-ci/linux-testimages'
  PROJECT_PATHS: '$OE_PROJECT_PATH $LINUX_TESTIMAGES_PROJECT_PATH'

workflow:
  rules:
    - if: $MANIFEST_BRANCH == ''
      variables:
        PROJECT_PATHS: '$MOCK_PROJECT_PATH'
        FORCE_TRIGGER: 'true'
      when: always
    - if: $MANIFEST_BRANCH == 'qcom/dunfell'
      variables:
        IMAGES: 'rpb-console-image rpb-console-image-test initramfs-tiny-image initramfs-test-image initramfs-test-full-image'
        IMAGES_RPB: 'rpb-desktop-image rpb-desktop-image-test'
        IMAGES_RPB_WAYLAND: 'rpb-weston-image rpb-weston-image-test'
        BUILD_SDK: 'rpb-console-image'
      when: always
    - if: $MANIFEST_BRANCH == 'qcom/honister'
      variables:
        IMAGES: 'rpb-console-image initramfs-tiny-image initramfs-test-image initramfs-test-full-image'
        IMAGES_RPB: 'rpb-desktop-image'
        IMAGES_RPB_WAYLAND: 'rpb-weston-image'
        BUILD_SDK: 'rpb-console-image'
      when: always
    - if: $MANIFEST_BRANCH == 'qcom/master'
      variables:
        IMAGES: 'rpb-console-image initramfs-tiny-image initramfs-test-image initramfs-test-full-image initramfs-rootfs-image'
        IMAGES_RPB: 'rpb-desktop-image'
        IMAGES_RPB_WAYLAND: 'rpb-weston-image'
      when: always
    - when: never

.cache:
  cache:
    key: $MANIFEST_BRANCH
    paths:
      - $REPO_DIR
      - $REPO_INFO
      - $REPO_DIFFMANIFESTS

.artifacts:
  artifacts:
    paths:
      - $REPO_INFO
      - $REPO_DIFFMANIFESTS

stages:
  - polling

poll selftest:
  extends:
    - .poll
    - .artifacts
    - .cache
  rules:
  - if: $MANIFEST_BRANCH == ''
    when: always

poll qcom/dunfell:
  extends:
    - .poll
    - .artifacts
    - .cache
  rules:
  - if: $MANIFEST_BRANCH == 'qcom/dunfell'
    when: always

poll qcom/honister:
  extends:
    - .poll
    - .artifacts
    - .cache
  rules:
  - if: $MANIFEST_BRANCH == 'qcom/honister'
    when: always

poll qcom/master:
  extends:
    - .poll
    - .artifacts
    - .cache
  rules:
  - if: $MANIFEST_BRANCH == 'qcom/master'
    when: always
